<?php
/**
 * @package Admin
 * @todo    Services page for WHMpress admin panel
 */

if ( ! defined( 'WHMP_VERSION' ) ) {
	wp_die( "Direct acces not allowed by WHMPress", "Forbidden" );
}
$WHMPress = new WHMpress();

## If styles are generic/default and (active_theme/whmpress exists or whmpress_folder/themes/active_theme folder exists)
if ( ( is_dir( get_template_directory() . "/whmpress/" ) || is_dir( WHMP_PLUGIN_PATH . "themes/" . basename( get_template_directory() ) ) ) && get_option( 'load_sytle_orders' ) == '' ) {
	?>
	<div class="notice notice-success is-dismissible">
		<h3>WHMPress</h3>
		<p><?php _e( 'Matching Templates found for your active theme <b>' . basename( get_template_directory() ) . '</b>. You can enable <b>' . basename( get_template_directory() ) . '</b> support by selecting Template Source from <a href="admin.php?page=whmp-settings#styles">Settings > Styles</a>.', 'whmpress' ); ?></p>
	</div>
	<?php
}

global $wpdb;
?>
<div class="wrap whmp_wrap">
	<h2></h2>
	<h2 class="nav-tab-wrapper">
		<a class="nav-tab"
		   href="<?php echo admin_url() ?>admin.php?page=whmp-dashboard"><?php echo __( 'Dashboard', 'whmpress' ); ?></a>
		<a class="nav-tab nav-tab-active"
		   href="<?php echo admin_url() ?>admin.php?page=whmp-services"><?php echo __( 'Products/Services', 'whmpress' ); ?></a>
		<a class="nav-tab"
		   href="<?php echo admin_url() ?>admin.php?page=whmp-settings"><?php echo __( 'Settings', 'whmpress' ); ?></a>
		<a class="nav-tab"
		   href="<?php echo admin_url() ?>admin.php?page=whmp-sync"><?php echo __( 'Sync WHMCS', 'whmpress' ); ?></a>
		<a class="nav-tab"
		   href="<?php echo admin_url() ?>admin.php?page=whmp-extensions"><?php echo __( 'Addons', 'whmpress' ); ?></a>
	</h2>
	<!--<div class="whmp-main-title"><span class="whmp-title">WHMpress</span> <?php /*_e("Services", "whmpress") */ ?></div>-->
	<?php if ( ! $WHMPress->WHMpress_synced() ): ?>
		
		<div class="whmp_admin_notice whmp_admin_notice_error">
			<h3><?php esc_html_e( "Products and Services", "whmpress" ) ?>:</h3>
			<p><strong><?php esc_html_e( "WHMCS is not Synced", "whmpress" ) ?></strong>
				<?php esc_html_e('You will not be able to view/modify any products until you sync WHMCS', 'whmpress')?></p>
			<a class="button button-primary" href="admin.php?page=whmp-sync"><?php _e( "Please Sync WHMCS", "whmpress" ) ?></a>
		</div>
	
	<?php else: ?>
		
		<div class="whmp_page_description">
			<p>
				<?php esc_html_e( "This page has all services list", "whmpress" ) ?>
			</p>
		</div>
		
		<?php
		$Q    = "SELECT DISTINCT `type` FROM `" . whmp_get_products_table_name() . "` WHERE `type`<>''";
		$tabs = whmp_get_service_types();
		?>
		
		<style>
			.mytr, .mytr th, .mytr th:hover {
				background-color: #666666 !important;
				color: #FFFFFF !important;
			}
		</style>
		
		<?php if ( isset( $_POST['save_values'] ) ) {
			unset( $_POST['save_values'] );
			foreach ( $_POST as $key => $value ) {
				update_option( $key, $value );
			}
		} ?>
		
		<div class="settings-wrap">
			<div id="whmp-services-tabs" class="tab-container">
				<ul class='etabs'>
					<?php $k = 1;
					foreach ( $tabs as $key => $tab ): ?>
						<li class='tab'><a href='#tab<?php echo $k ?>'><?php echo $tab ?></a></li>
						<?php $k ++; endforeach; ?>
					<li class='tab'><a href="#domains"><?php esc_html_e( "Domains", "whmpress" ) ?></a></li>
					<li class='tab'><a href="#currencies"><?php esc_html_e( "Currencies", "whmpress" ) ?></a></li>
				</ul>
				
				<form name="" method="post">
					<input type="hidden" name="save_values" value="1">
					<?php $k = 1;
					foreach ( $tabs as $key => $tab ) { ?>
						<div id='tab<?php echo $k ?>'>
							<table class="fancy" style="width:100%">
								<thead>
								<tr class="mytr">
									<th style="width:4%"><?php esc_html_e( "ID", "whmpress" ) ?></th>
									<th style="width:24%"><?php esc_html_e( "Name", "whmpress" ) ?> <span class="dashicons dashicons-translation"></span></th>
									<th style="width:24%"><?php esc_html_e( 'Description', 'whmpress' ) ?> <span class="dashicons dashicons-translation"></span></th>
									<th style="width:24%"><?php esc_html_e( 'Description Override', 'whmpress' ) ?> <span class="dashicons dashicons-translation"></span></th>
									<th style="width:24%"><?php esc_html_e( 'Description Append', 'whmpress' ) ?> <span class="dashicons dashicons-translation"></span></th>
								</tr>
								</thead>
								<tbody>
								<?php
								$groups = $wpdb->get_results( "SELECT `id`,`name`,`hidden` FROM `" . whmp_get_product_group_table_name() . "` ORDER BY `order`", ARRAY_A );
								foreach ( $groups as $group ) {
									$rows = $wpdb->get_results( "SELECT `id`, `name`,`description`,`hidden` FROM `" . whmp_get_products_table_name() . "` WHERE `gid`='{$group["id"]}' AND `type`='{$key}' ORDER BY `name`" );
									if ( is_array( $rows ) && sizeof( $rows ) > 0 ) {
										$hidden = $group["hidden"] == "on" ? " (<i>" . __( 'Hidden', 'whmpress' ) . "</i>)" : "";
										foreach ( $rows as $row ): ?>
											<tr>
												<td><?php echo $row->id; ?></td>
												<td>
													<label>
														<?php echo $row->name;
														if ( $row->hidden == "on" )
															echo " (<i>" . __( 'Hidden', 'whmpress' ) . "<i>)" ?>
														<br>
														<?php $field = "whmpress_product_" . $row->id . "_name_" . $WHMPress->get_current_language(); ?>
														<input style="padding:5px; width: 100%;"
														       placeholder="<?php esc_html_e( "Name override for current language" ); ?>"
														       type="text" data-name="<?php echo $field; ?>"
														       value="<?php echo esc_attr( get_option( $field ) ) ?>">
													</label>
													<br>
													
													<!--													<?php /*$field = "whmpress_product_" . $row->id . "_showoff_price"; */ ?>
													<label>Show off Price<br>
													<input style="padding:5px; width: 100%;" class="input"
													       type="text" data-name="<?php /*echo $field; */ ?>"
													       value="<?php /*echo esc_attr( get_option( $field ) ) */ ?>">
													</label>-->
													
													<?php $field = "whmpress_product_" . $row->id . "_custom_desc_" . $WHMPress->get_current_language(); ?>
													<label><?php esc_html_e( 'Tag line', 'whmpress' ) ?><br>
														<input style="padding:5px; width: 100%;" class="input"
														       type="text" data-name="<?php echo $field; ?>"
														       value="<?php echo esc_attr( get_option( $field ) ) ?>">
													</label>
												
												</td>
												<td style="vertical-align: top;">
													<div style="max-height: 100px; overflow-y: auto;">
														<?php echo $row->description; ?>&nbsp;
													</div>
												</td>
												<td>
													<div>
														<?php $field = "whmpress_product_" . $row->id . "_desc_" . $WHMPress->get_current_language(); ?>
														<textarea data-name="<?php echo $field ?>" cols="30" rows="5"
														          placeholder="<?php esc_html_e( 'Override description according to current language', 'whmpress' ) ?>"><?php echo esc_attr( get_option( $field ) ); ?></textarea>
													</div>
												</td>
												<td>
													<div>
														<?php $field = "whmpress_product_" . $row->id . "_append_desc_" . $WHMPress->get_current_language(); ?>
														<textarea data-name="<?php echo $field ?>" cols="30" rows="5"
														          class="whmp_multilingual_input"
														          placeholder="<?php esc_html_e( 'Append description according to current language', 'whmpress' ) ?>"><?php echo esc_attr( get_option( $field ) ); ?></textarea>
													</div>
												</td>
											</tr>
										<?php endforeach;
									}
								} ?>
								</tbody>
							</table>
							<button class="button button-primary"><?php esc_html_e( "Save", "whmpress" ); ?></button>
						</div>
						<?php $k ++;
					} ?>
					<div id="domains">
						<?php
						$Q            = "SELECT `id`,`extension`,`group` FROM `" . whmp_get_domain_pricing_table_name() . "` ORDER BY `order`";
						$rows_domains = $wpdb->get_results( $Q, ARRAY_A );
						foreach ( $rows_domains as &$row ) {
							$row['registration_price'] = $WHMPress->get_domain_price( [
								"extension" => $row['extension'],
							] );
							$row['renew_price']        = $WHMPress->get_domain_price( [
								"extension"  => $row['extension'],
								"price_type" => "renew",
							] );
							$row['transfer_price']     = $WHMPress->get_domain_price( [
								"extension"  => $row['extension'],
								"price_type" => "transfer",
							] );
						}
						?>
						<div> <?php echo __( 'You are selling', 'whmpress' ) . " " . count( $rows_domains ); ?> domain(s)</div>
						<table class="fancy" style="width:100%">
							<thead>
							<tr>
								<th><?php _e( "ID", "whmpress" ) ?></th>
								<th><?php _e( "Group", "whmpress" ) ?></th>
								<th><?php _e( "Domain", "whmpress" ) ?></th>
								<th><?php _e( "Registeration", "whmpress" ) ?></th>
								<th><?php _e( "Renewel", "whmpress" ) ?></th>
								<th><?php _e( "Transfer", "whmpress" ) ?></th>
								<th><?php _e( "Restore", "whmpress" ) ?></th>
								<th><?php _e( "Promo", "whmpress" ) ?></th>
								<th><?php _e( "Promo Text", "whmpress" ) ?></th>
								<th><?php _e( "Promo Details", "whmpress" ) ?></th>
								<th><?php _e( "Register Off", "whmpress" ) ?></th>
								<th><?php _e( "Renew Off", "whmpress" ) ?></th>
								<th><?php _e( "Transfer Off", "whmpress" ) ?></th>
								<th><?php _e( "Apply all years", "whmpress" ) ?></th>
							</tr>
							</thead>
							<tbody>
							<?php
							for ( $index = 0; $index < count( $rows_domains ); $index ++ ) { ?>
								<tr data-id="<?php echo $rows_domains[ $index ]["id"] ?>">
									<td><?php echo $rows_domains[ $index ]["id"] ?></td>
									<td><?php echo $rows_domains[ $index ]["group"] ?></td>
									<td><?php echo $rows_domains[ $index ]["extension"] ?></td>
									<td><?php echo $rows_domains[ $index ]["registration_price"] ?></td>
									<td><?php echo $rows_domains[ $index ]["renew_price"] ?></td>
									<td><?php echo $rows_domains[ $index ]["transfer_price"] ?></td>
									
									<?php $field = "whmpress_domain_restore_price_" . $rows_domains[ $index ]["id"]; ?>
									<td>
										<input value="<?php echo esc_attr( get_option( $field ) ) ?>"
										       class="input" data-name="<?php echo $field ?>"
										       type="number" min="0" style="max-width:70px;">
									</td>
									
									<?php $field = "whmpress_domain_promo_" . $rows_domains[ $index ]["id"]; ?>
									<td>
										<input class="input" data-name="<?php echo $field ?>" type="checkbox" value="1" <?php echo get_option( $field ) == "1" ? "checked=checked" : ""; ?>>
									</td>
									
									<?php $field = "whmpress_domain_promo_text_" . $rows_domains[ $index ]["id"] . $WHMPress->get_current_language(); ?>
									<td>
										<input class="input" data-name="<?php echo $field ?>" type="text" value="<?php echo esc_attr( get_option( $field ) ) ?>">
									</td>
									
									<?php $field = "whmpress_domain_promo_details_" . $rows_domains[ $index ]["id"] . $WHMPress->get_current_language(); ?>
									<td>
										<textarea class="input" data-name="<?php echo $field ?>" rows="1"><?php echo esc_attr( get_option( $field ) ) ?></textarea>
									</td>
									
									<?php $field = "whmpress_domain_promo_register_off_price_" . $rows_domains[ $index ]["id"]; ?>
									<td>
										<input class="input" data-name="<?php echo $field ?>" type="number" min="0" style="max-width:70px;" value="<?php echo esc_attr( get_option( $field ) ) ?>">
									</td>
									
									<?php $field = "whmpress_domain_promo_renew_off_price_" . $rows_domains[ $index ]["id"]; ?>
									<td>
										<input class="input" data-name="<?php echo $field ?>" type="number" min="0" style="max-width:70px;" value="<?php echo esc_attr( get_option( $field ) ) ?>">
									</td>
									
									<?php $field = "whmpress_domain_promo_transfer_off_price_" . $rows_domains[ $index ]["id"]; ?>
									<td>
										<input class="input" data-name="<?php echo $field ?>" type="number" min="0" style="max-width:70px;" value="<?php echo esc_attr( get_option( $field ) ) ?>">
									</td>
									
									<?php $field = "whmpress_domain_promo_apply_all_" . $rows_domains[ $index ]["id"]; ?>
									<td>
										<input class="input" data-name="<?php echo $field ?>" type="checkbox" value="1" <?php echo get_option( $field ) == "1" ? "checked=checked" : ""; ?>>
									</td>
								</tr>
							<?php } ?>
							<tr>
								<td colspan="14" style="text-align: center;">

									<input type="submit" value="<?php esc_html_e("Save","whmpress")?>" class="button-primary"></td>
							</tr>
							</tbody>
						</table>
					</div>
					<div id="currencies">
						<?php
						$WHMPress->update_db();
						$Q    = "SELECT * FROM `" . whmp_get_currencies_table_name() . "`";
						$rows = $wpdb->get_results( $Q, ARRAY_A );
						?>
						<button class="button button-primary"><?php esc_html_e( "Save", "whmpress" ); ?></button>
						<table class="fancy" style="width:100%">
							<thead>
							<tr>
								<th><?php esc_html_e( "ID", "whmpress" ) ?> <span class="dashicons dashicons-translation"></span></th>
								<th><?php esc_html_e( "Code", "whmpress" ) ?> <span class="dashicons dashicons-translation"></span></th>
								<th><?php esc_html_e( "Prefix", "whmpress" ) ?> <span class="dashicons dashicons-translation"></span></th>
								<th><?php esc_html_e( "Suffix", "whmpress" ) ?> <span class="dashicons dashicons-translation"></span></th>
								<th><?php esc_html_e( "Decimal Sep.", "whmpress" ) ?> <span class="dashicons dashicons-translation"></span></th>
								<th><?php esc_html_e( "Thousand Sep.", "whmpress" ) ?> <span class="dashicons dashicons-translation"></span></th>
							</tr>
							</thead>
							<tbody>
							<?php
							foreach ( $rows as $row ) {
								$whmcs_decimal = '';
								$whmcs_thousand = '';
								switch ($row['format']) {
									case '1': {
										$whmcs_decimal = '.';
										break;
									}
									case '2': {
										$whmcs_decimal = '.';
										$whmcs_thousand = ',';
										break;
									}
									case '3': {
										$whmcs_decimal = ',';
										$whmcs_thousand = '.';
										break;
									}
									case '4': {
										$whmcs_decimal = '.';
										$whmcs_thousand = ',';
										break;
									}
									default: {
										$whmcs_decimal = '.';
										$whmcs_thousand = ',';
									}
								}
								
								?>
								<tr>
									<td><?php echo $row["id"] ?><?php if ( $row["default"] == "1" )
											echo " <sup>[default]</sup>" ?></td>
									<td>
										<?php echo $row["code"] ?>
										<?php $field = "whmpress_currencies_" . trim( $row['code'] ) . "_code_" . $WHMPress->get_current_language(); ?>
										<input placeholder="<?php esc_html_e( "Override code", "whmpress" ); ?>" type="text"
										       data-name="<?php echo $field ?>"
										       value="<?php echo esc_attr( get_option( $field ) ); ?>">
									</td>
									<td>
										<?php echo $row["prefix"] ?>
										<?php $field = "whmpress_currencies_" . trim( $row['prefix'] ) . "_prefix_" . $WHMPress->get_current_language(); ?>
										<input placeholder="<?php esc_html_e( "Override pefix", "whmpress" ); ?>" type="text"
										       data-name="<?php echo $field ?>"
										       value="<?php echo esc_attr( get_option( $field ) ); ?>">
									</td>
									<td>
										<?php echo( $row["suffix"] ); ?>
										<?php $field = "whmpress_currencies_" . trim( $row['suffix'] ) . "_suffix_" . $WHMPress->get_current_language(); ?>
										<input placeholder="<?php esc_html_e( "Override suffix", "whmpress" ); ?>" type="text"
										       data-name="<?php echo $field ?>"
										       value="<?php echo esc_attr( get_option( $field ) ); ?>">
									</td>
									<td>
										<?php echo $whmcs_decimal; ?>
										<?php $field = "whmpress_currencies_" . trim( $row['id'] ) . "_decimal_" . $WHMPress->get_current_language(); ?>
										<input placeholder="<?php esc_html_e( "Override decimal separator", "whmpress" ); ?>"
										       type="text"
										       data-name="<?php echo $field ?>"
										       value="<?php echo esc_attr( get_option( $field ) ); ?>">
									</td>
									<td>
										<?php echo $whmcs_thousand; ?>
										<?php $field = "whmpress_currencies_" . trim( $row['id'] ) . "_thousand_" . $WHMPress->get_current_language(); ?>
										<input placeholder="<?php esc_html_e( "Override thousand separator", "whmpress" ); ?>"
										       type="text"
										       data-name="<?php echo $field ?>"
										       value="<?php echo esc_attr( get_option( $field ) ); ?>">
									</td>
								</tr>
							<?php } ?>
							</tbody>
						</table>
						<button class="button button-primary"><?php esc_html_e( "Save", "whmpress" ); ?></button>
					</div>
				</form>
			</div>
		</div>
	<?php endif; ?>
</div>

<script type="text/javascript">
	jQuery(document).ready(function ()
	{
		jQuery('#whmp-services-tabs').easytabs();
		
		jQuery(document).on("change", "[data-name]", function (event)
		{
			event.preventDefault();
			
			var $this = jQuery(this);
			var name = $this.data("name");
			
			if ($this.is(":checkbox")) {
				val = $this.is(":checked") ? "1" : "0";
			}
			else if ($this.is(":radio")) {
				val = $this.is(":checked") ? "1" : "0";
			}
			else {
				var val = $this.val();
			}
			
			//$this.prop("disabled", true);
			$this.val("Saving...");
			$this.attr('disabled', true);
			jQuery.post(
				ajaxurl,
				{
					action: 'whmpress_update_field',
					name: name,
					val: val
				},
				function (data) {
					$this.attr('disabled', false);
					$this.val(val);
					if ($this.is(":checkbox")) {
						if (val == "1"){
							$this.attr('checked', true)
						}
						else {
							$this.attr('checked', false)
						}
					}
					else if ($this.is(":radio")) {
						if (val == "1"){
							$this.attr('checked', true)
						}
						else {
							$this.attr('checked', false)
						}
					}
					else {
						$this.val(val);
					}
				});
		});
	});
</script>